fstests.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: Xiao Yang <yangx.jy@cn.fujitsu.com>
To: <guaneryu@gmail.com>
Cc: <fstests@vger.kernel.org>, <darrick.wong@oracle.com>,
	<ira.weiny@intel.com>, Xiao Yang <yangx.jy@cn.fujitsu.com>
Subject: [PATCH v8 7/7] generic: Verify the inheritance behavior of FS_XFLAG_DAX flag in various combinations
Date: Mon, 3 Aug 2020 16:38:38 +0800	[thread overview]
Message-ID: <20200803083838.26222-8-yangx.jy@cn.fujitsu.com> (raw)
In-Reply-To: <20200803083838.26222-1-yangx.jy@cn.fujitsu.com>

Also factor out _check_xflag() so that other tests can use it in future.

Signed-off-by: Xiao Yang <yangx.jy@cn.fujitsu.com>
---
 common/rc             |  12 +++
 tests/generic/607     | 187 ++++++++++++++++++++++++++++++++++++++++++
 tests/generic/607.out |   2 +
 tests/generic/group   |   1 +
 4 files changed, 202 insertions(+)
 create mode 100644 tests/generic/607
 create mode 100644 tests/generic/607.out

diff --git a/common/rc b/common/rc
index a358702e..9af0aa72 100644
--- a/common/rc
+++ b/common/rc
@@ -3209,6 +3209,18 @@ _check_s_dax()
 	fi
 }
 
+_check_xflag()
+{
+	local target=$1
+	local exp_xflag=$2
+
+	if [ $exp_xflag -eq 0 ]; then
+		_test_inode_flag dax $target && echo "$target has unexpected FS_XFLAG_DAX flag"
+	else
+		_test_inode_flag dax $target || echo "$target doen't have expected FS_XFLAG_DAX flag"
+	fi
+}
+
 # Only accept dax/dax=always mount option becasue dax=always, dax=inode
 # and dax=never are always introduced together.
 # Return 0 if filesystem/device supports the specified dax option.
diff --git a/tests/generic/607 b/tests/generic/607
new file mode 100644
index 00000000..f7e17cb3
--- /dev/null
+++ b/tests/generic/607
@@ -0,0 +1,187 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Fujitsu.  All Rights Reserved.
+#
+# FS QA Test 607
+#
+# Verify the inheritance behavior of FS_XFLAG_DAX flag in various combinations.
+# 1) New files and directories automatically inherit FS_XFLAG_DAX from their parent directory.
+# 2) cp operation make files and directories inherit the FS_XFLAG_DAX from new parent directory.
+# 3) mv operation make files and directories preserve the FS_XFLAG_DAX from old parent directory.
+# In addition, setting/clearing FS_XFLAG_DAX flag is not impacted by dax mount options.
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1        # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_dax_iflag
+_require_xfs_io_command "lsattr" "-v"
+
+# If a/ is +x, check that a's new children
+# inherit +x from a/.
+test_xflag_inheritance1()
+{
+	mkdir -p a
+	$XFS_IO_PROG -c "chattr +x" a
+	mkdir -p a/b/c
+	touch a/b/c/d
+
+	_check_xflag a 1
+	_check_xflag a/b 1
+	_check_xflag a/b/c 1
+	_check_xflag a/b/c/d 1
+
+	rm -rf a
+}
+
+# If a/ is +x and b/ is -x, check that:
+# 1) b's new children inherit -x from b/.
+# 2) a's new children(b/ is old) inherit +x from a/.
+test_xflag_inheritance2()
+{
+	mkdir -p a/b
+	$XFS_IO_PROG -c "chattr +x" a
+	mkdir -p a/b/c a/d
+	touch a/b/c/e a/d/f
+
+	_check_xflag a 1
+	_check_xflag a/b 0
+	_check_xflag a/b/c 0
+	_check_xflag a/b/c/e 0
+	_check_xflag a/d 1
+	_check_xflag a/d/f 1
+
+	rm -rf a
+}
+
+# If a/ is -x and b/ is +x, check that:
+# 1) b's new children inherit +x from b/.
+# 2) a's new children(b/ is old) inherit -x from a/.
+test_xflag_inheritance3()
+{
+	mkdir -p a/b
+	$XFS_IO_PROG -c "chattr +x" a/b
+	mkdir -p a/b/c a/d
+	touch a/b/c/e a/d/f
+
+	_check_xflag a 0
+	_check_xflag a/b 1
+	_check_xflag a/b/c 1
+	_check_xflag a/b/c/e 1
+	_check_xflag a/d 0
+	_check_xflag a/d/f 0
+
+	rm -rf a
+}
+
+# If a/, c/ are +x and b/ is -x, check that:
+# 1) c's new children inherit +x from c/.
+# 2) b's new children(c/ is old) inherit -x from b/.
+test_xflag_inheritance4()
+{
+	mkdir -p a
+	$XFS_IO_PROG -c "chattr +x" a
+	mkdir -p a/b/c
+	$XFS_IO_PROG -c "chattr -x" a/b
+	mkdir -p a/b/c/d a/b/e
+	touch a/b/c/d/f a/b/e/g
+
+	_check_xflag a 1
+	_check_xflag a/b 0
+	_check_xflag a/b/c 1
+	_check_xflag a/b/c/d 1
+	_check_xflag a/b/c/d/f 1
+	_check_xflag a/b/e 0
+	_check_xflag a/b/e/g 0
+
+	rm -rf a
+}
+
+# If a/ is +x and b/ is -x, check that:
+# 1) new b/c and b/g inherit -x from b/ by cp.
+# 2) new a/e inherits +x from a/ by cp.
+# 3) new b/d preserves +x from a/ by mv.
+# 4) new a/f and a/h preserve -x from b/ by mv.
+test_xflag_inheritance5()
+{
+	mkdir -p a b
+	$XFS_IO_PROG -c "chattr +x" a
+	mkdir -p a/c a/d b/e b/f
+	touch a/g b/h
+
+	cp -r a/c b/
+	cp -r b/e a/
+	cp -r a/g b/
+	mv a/d b/
+	mv b/f a/
+	mv b/h a/
+
+	_check_xflag b/c 0
+	_check_xflag b/d 1
+	_check_xflag a/e 1
+	_check_xflag a/f 0
+	_check_xflag b/g 0
+	_check_xflag a/h 0
+
+	rm -rf a b
+}
+
+do_xflag_tests()
+{
+	local option=$1
+
+	_scratch_mkfs >> $seqres.full 2>&1
+	_scratch_mount "$option"
+	cd $SCRATCH_MNT
+
+	for i in $(seq 1 5); do
+		test_xflag_inheritance${i}
+	done
+
+	cd - > /dev/null
+	_scratch_unmount
+}
+
+do_tests()
+{
+	# Mount without dax option
+	do_xflag_tests
+
+	# Mount with 'dax' or 'dax=always' option if fs supports it.
+	_check_scratch_dax_mountopt "dax" && do_xflag_tests "-o dax"
+
+	# Mount with 'dax=inode' and 'dax=never' options if fs supports them.
+	if _check_scratch_dax_mountopt "dax=always"; then
+		for dax_option in "dax=inode" "dax=never"; do
+			do_xflag_tests "-o $dax_option"
+		done
+	fi
+}
+
+do_tests
+
+# success, all done
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/generic/607.out b/tests/generic/607.out
new file mode 100644
index 00000000..d02de53b
--- /dev/null
+++ b/tests/generic/607.out
@@ -0,0 +1,2 @@
+QA output created by 607
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index 05c6b02d..5bd289c3 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -609,3 +609,4 @@
 604 auto quick mount
 605 auto attr quick dax
 606 auto attr quick dax
+607 auto attr quick dax
-- 
2.21.0




  parent reply	other threads:[~2020-08-03  8:46 UTC|newest]

Thread overview: 13+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-08-03  8:38 [PATCH v8 0/7] Make fstests support new behavior of DAX Xiao Yang
2020-08-03  8:38 ` [PATCH v8 1/7] common/rc: Introduce helpers for new dax mount options and FS_XFLAG_DAX Xiao Yang
2020-08-03 19:49   ` Ira Weiny
2020-08-03 22:26     ` Darrick J. Wong
2020-08-04  1:26       ` Xiao Yang
2020-08-03  8:38 ` [PATCH v8 2/7] fstests: Use _require_scratch_dax_mountopt() and _require_dax_iflag() Xiao Yang
2020-08-03  8:38 ` [PATCH v8 3/7] generic/223: Don't clear MKFS_OPTION before calling _scratch_mkfs_geom() Xiao Yang
2020-08-03  8:38 ` [PATCH v8 4/7] generic/413, xfs/260: Improve format operation for PMD fault testing Xiao Yang
2020-08-03  8:38 ` [PATCH v8 5/7] xfs/260: Move and update xfs/260 Xiao Yang
2020-08-03  8:38 ` [PATCH v8 6/7] generic: Verify if statx() can qurey S_DAX flag on regular file correctly Xiao Yang
2020-08-03  8:38 ` Xiao Yang [this message]
2020-08-03 19:54   ` [PATCH v8 7/7] generic: Verify the inheritance behavior of FS_XFLAG_DAX flag in various combinations Ira Weiny
2020-08-03 22:25   ` Darrick J. Wong

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200803083838.26222-8-yangx.jy@cn.fujitsu.com \
    --to=yangx.jy@cn.fujitsu.com \
    --cc=darrick.wong@oracle.com \
    --cc=fstests@vger.kernel.org \
    --cc=guaneryu@gmail.com \
    --cc=ira.weiny@intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).